
/***************************************************************************
**                         BIBOM - LODERUNNER                             **
**                      Copyright (C) 2002-2003,                          **
**                Vincent Pelletier <vpel@mageos.com>                     **
**                                                                        **
**  This program is free software; you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation; either version 2 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         **
**  GNU General Public License for more details.                          **
***************************************************************************/ 

#include "Enemy.hpp"

// --------------------------------------------------------

Enemy::Enemy(Environment *env, MapManager* aMap,SDL_Surface *aSprite,Hero* anHero,int aSpeed)
:Character(env, aMap,aSprite,aSpeed)
{
	position = map->getEnemyEntryPoint();
	hero = anHero;
}

// --------------------------------------------------------

Enemy::~Enemy()
{
}

// --------------------------------------------------------

void Enemy::newLevel(void)
{
	initialize();
	checkCurrentPosition();
}

// --------------------------------------------------------

void Enemy::move(void) 
{
	if(!isMoveWaiting())
	{
		const GLPoint& heroPosition = hero->getPosition();
		bool moveOk = false;

		if(heroPosition.y > position.y)
			moveOk = moveDown();
		if((!moveOk)&& (heroPosition.y < position.y))
			moveOk = moveUp();		
		if((!moveOk) && (heroPosition.x > position.x))
			moveOk = moveRight();
		if((!moveOk) && (heroPosition.x < position.x))
			moveOk = moveLeft();
	}
}

// --------------------------------------------------------

void Enemy::initialize(void)
{
	Character::initialize();
	setPosition(map->getEnemyEntryPoint().x, map->getEnemyEntryPoint().y);
}

// --------------------------------------------------------
