
/***************************************************************************
**                         BIBOM - LODERUNNER                             **
**                      Copyright (C) 2002-2003,                          **
**                Vincent Pelletier <vpel@mageos.com>                     **
**                                                                        **
**  This program is free software; you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation; either version 2 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         **
**  GNU General Public License for more details.                          **
***************************************************************************/ 

#ifndef _GAME_
#define _GAME_


#include "DisplayManager.hpp"
#include "MapManager.hpp"
#include "Environment.hpp"

// --------------------------------------------------------

#define _DELAY_CREDITS		3000

// --------------------------------------------------------

class Game
{
	private:
		DisplayManager *display;
		MapManager *map;
	
		EMenuChoice menuChoice;
	public:	
		Game(void);
		virtual ~Game();

		void run(void);
		void runMenu(void);
		void runGame(void);
		int runLevel(Environment* env);

		void credits(void);

	protected:
		void clearEvents(void);
};

// --------------------------------------------------------

#endif	// _GAME_
