
/***************************************************************************
**                         BIBOM - LODERUNNER                             **
**                      Copyright (C) 2002-2003,                          **
**                Vincent Pelletier <vpel@mageos.com>                     **
**                                                                        **
**  This program is free software; you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation; either version 2 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         **
**  GNU General Public License for more details.                          **
***************************************************************************/ 

#ifndef _HERO_
#define _HERO_

#include "Character.hpp"
#include "Environment.hpp"

// --------------------------------------------------------

class Hero : public Character
{
	private:
		int lifeCount;
		int keysCount;

	public:
		Hero(Environment *env, MapManager* m,SDL_Surface *sprite,int speed,int nblives);
		virtual ~Hero();

		bool finishLevel(void);
		void newLevel(void);
		void putHoleRight(void);
		void putHoleLeft(void);

		int getKeysCount(void);
		int getLifeCount(void);
		bool isDead(void);
		void collide(void);

		virtual void checkCurrentPosition(void);
		virtual void exitScreen(void);
		virtual void crush(void);
		virtual void initialize(void);
		virtual void setPosition(int x, int y);
};

// --------------------------------------------------------
// inline methods

inline
int Hero::getKeysCount(void)
{
	return keysCount;
}

// --------------------------------------------------------

inline
int Hero::getLifeCount(void)
{
	return lifeCount;
}

// --------------------------------------------------------

inline
bool Hero::isDead(void)
{
	return (lifeCount==0);
}

// --------------------------------------------------------

#endif // _HERO_

