
/***************************************************************************
**                         BIBOM - LODERUNNER                             **
**                      Copyright (C) 2002-2003,                          **
**                                                                        **
**  This program is free software; you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation; either version 2 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         **
**  GNU General Public License for more details.                          **
***************************************************************************/ 

#ifndef _RESOURCEPOOL_
#define _RESOURCEPOOL_

// --------------------------------------------------------

#include "toollib/TLDictionary.hpp"
#include <SDL.h>

// --------------------------------------------------------

/**
 * @todo : replace, imagePool array by a dictionary to not load twice a same image.
 */
class ResourcePool
{
	public:
		typedef enum {itBMP} EImageType;

		static ResourcePool defaultPool;

	private:
		TLDictionary imagePool;
		char *imageFolder;

	private:
		ResourcePool(void);

	public:
		virtual ~ResourcePool();

		SDL_Surface *loadImage(const char *name, EImageType type = itBMP);
		SDL_Surface *getImage(const char *name);
		void setImageFolder(const char *);
		const char *getImageFolder(void) const;
};

// --------------------------------------------------------
// inline methodes

inline
const char *ResourcePool::getImageFolder(void) const
{
	return imageFolder;
}

// --------------------------------------------------------

#endif	// _RESOURCEPOOL_
