
/***************************************************************************
**                         BIBOM - LODERUNNER                             **
**                      Copyright (C) 2002-2003,                          **
**                                                                        **
**  This program is free software; you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation; either version 2 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         **
**  GNU General Public License for more details.                          **
***************************************************************************/ 

#ifndef _GLFONT_
#define _GLFONT_

#include "GLPoint.hpp"

#include <SDL.h>
#include <SDL_image.h>

// --------------------------------------------------------

/**
 * Graphical Font
 *
 */
class GLFont
{
	public:
		GLPoint letterSize;
		GLPoint fontSize;
		SDL_Surface *image;

	public:
		GLFont(void);
		GLFont(const char *imgFile, int w, int h, int columns, int rows);
		virtual ~GLFont();

		void writeText(const GLPoint& position, const char *text, SDL_Surface *surface);
		GLPoint getTextSize(const char *text) const;

		const GLPoint& getLetterSize(void) const;
	protected:
		bool writeCharacter(const GLPoint& position, char letter, SDL_Surface *surface);
		bool getCharacterRect(char letter, SDL_Rect *rect);
};

// --------------------------------------------------------
// inline methods

inline
const GLPoint& GLFont::getLetterSize(void) const
{
	return letterSize;
}

// --------------------------------------------------------

#endif _GLFONT_
