
/***************************************************************************
**                         BIBOM - LODERUNNER                             **
**                      Copyright (C) 2002-2003,                          **
**                Vincent Pelletier <vpel@mageos.com>                     **
**                                                                        **
**  This program is free software; you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation; either version 2 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         **
**  GNU General Public License for more details.                          **
***************************************************************************/ 

#include "Game.hpp"
#include "ResourcePool.hpp"
#include "OptionsManager.hpp"

int main (int argc, char* argv[])
{
	Game *game;

	// options
	OptionsManager::defaultManager.load("./data/bibom.cfg");

	// images
	ResourcePool::defaultPool.setImageFolder(OptionsManager::defaultManager.getFolders().images);

	// game
	game = new Game();

	game->run();

	return 0;
}
