
/***************************************************************************
**                         BIBOM - LODERUNNER                             **
**                      Copyright (C) 2002-2003,                          **
**                                                                        **
**  This program is free software; you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation; either version 2 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         **
**  GNU General Public License for more details.                          **
***************************************************************************/ 

#include "TLArray.hpp"

#include <stdlib.h>

// --------------------------------------------------------

TLArray::TLArray(bool destroyFlag)
{
	count = 0;
	seed = DEFAULT_SEED;
	capacity = seed;
	elements = new void *[capacity];
	destroy = destroyFlag;
}

// --------------------------------------------------------

TLArray::~TLArray()
{
	if(elements != NULL)
	{
		if(destroy)
		{
			for(int i=0; i<count; i++)
				delete elements[i];
		}

		delete[] elements;
	}
}

// --------------------------------------------------------

int TLArray::add(void *element)
{
	if(count >= capacity)
		enlarge(seed);

	elements[count] = element;

	return count++;
}

// --------------------------------------------------------

void TLArray::remove(int index)
{
	if((index>=0)&&(index<count))
	{
		for(int i=index+1; i<count; i++)
			elements[i-1] = elements[i];
		count--;
	}
}

// --------------------------------------------------------

void TLArray::clear(void)
{
	count = 0;
}

// --------------------------------------------------------

/**
 *
 * @todo : create an exception class.
 */
void *& TLArray::operator[](int index) const
{
	if((index>=0)&&(index<count))
		return elements[index];
	else
		throw "bad index for this TLArray.";
}

// --------------------------------------------------------

void TLArray::enlarge(int size)
{
	void **newArray;

	newArray = new void *[capacity + size];
	if(elements != NULL)
	{
		for(int i=0; i< count; i++)
			newArray[i] = elements[i];
		delete[] elements;
	}
	elements = newArray;
	capacity += size;
}

// --------------------------------------------------------
