
/***************************************************************************
**                         BIBOM - LODERUNNER                             **
**                      Copyright (C) 2002-2003,                          **
**                                                                        **
**  This program is free software; you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation; either version 2 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         **
**  GNU General Public License for more details.                          **
***************************************************************************/ 

#ifndef _TLARRAY_
#define _TLARRAY_

// --------------------------------------------------------

#define DEFAULT_SEED	10

// --------------------------------------------------------

/**
 * Dynamic array
 *
 * @todo : manage decrementation of capacity when removing.
 */
class TLArray
{
	private:
		int count;
		int capacity;
		void **elements;

		int seed;
		bool destroy;
	public:
		TLArray(bool destroyFlag = false);
		virtual ~TLArray();

		int add(void *element);
		void remove(int index);
		void clear(void);

		void *& operator[](int index) const;

		void setDestroy(bool destroyFlag);
		int getCount(void) const;

	protected:
		void enlarge(int size);
};

// --------------------------------------------------------
// inline methods

inline
void TLArray::setDestroy(bool destroyFlag)
{
	destroy = destroyFlag;
}

// --------------------------------------------------------

inline
int TLArray::getCount(void) const
{
	return count;
}

// --------------------------------------------------------

#endif	// _TLARRAY_


