
/***************************************************************************
**                         BIBOM - LODERUNNER                             **
**                      Copyright (C) 2002-2003,                          **
**                                                                        **
**  This program is free software; you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation; either version 2 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         **
**  GNU General Public License for more details.                          **
***************************************************************************/ 

#include "TLFiles.hpp"

#include <io.h>

// --------------------------------------------------------

TLFiles::TLFiles(void)
{
	// no instance of this class should be created.
	// @todo throw an exception...
}

// --------------------------------------------------------

TLFiles::~TLFiles()
{
	// nothing to do...
}

// --------------------------------------------------------

// return false if there is an error or if this is the end of file.
bool TLFiles::readLine(int file, char *line, int size)
{
	int i = 0;
	int ret = 1;
	bool end = true;

	if(file < 0)
		return false;

	while((i < size - 1) && (ret > 0))
	{
		ret = read(file, &(line[i]), sizeof(char));
		if(ret == -1)
			return false;
		else if(ret > 0)
		{
			if(line[i] == '\n')
				ret = 0;
			else
				i++;
		}
		else
			end = false;
	}
	line[i] = '\0';

	return end;
}

// --------------------------------------------------------


